/*
 * Copyright (c) 2010  Pekka Enberg
 *
 * This file is released under the GPL version 2 with the following
 * clarification and special exception:
 *
 *     Linking this library statically or dynamically with other modules is
 *     making a combined work based on this library. Thus, the terms and
 *     conditions of the GNU General Public License cover the whole
 *     combination.
 *
 *     As a special exception, the copyright holders of this library give you
 *     permission to link this library with independent modules to produce an
 *     executable, regardless of the license terms of these independent
 *     modules, and to copy and distribute the resulting executable under terms
 *     of your choice, provided that you also meet, for each linked independent
 *     module, the terms and conditions of the license of that module. An
 *     independent module is a module which is not derived from or based on
 *     this library. If you modify this library, you may extend this exception
 *     to your version of the library, but you are not obligated to do so. If
 *     you do not wish to do so, delete this exception statement from your
 *     version.
 *
 * Please refer to the file LICENSE for details.
 */

#include "lib/parse.h"

#include <strings.h>
#include <stdlib.h>

static unsigned long parse_unit(const char *start)
{
	if (*start == '\0')
		return 1;
	if (!strcasecmp(start, "k"))
		return 1024;
	if (!strcasecmp(start, "m"))
		return 1024*1024;
	if (!strcasecmp(start, "g"))
		return 1024*1024*1024;

	return 0;
}

unsigned long parse_long(const char *arg)
{
	unsigned long ret;
	char *end;

	ret	= strtoul(arg, &end, 10);

	ret	*= parse_unit(end);

	return ret;
}
